%Time needed for one normal or combined request. Amount of data consumed for one request.

\chapter{Testing}
This chapter contains a summary of tests created to ensure the patches do enable merges under the specified conditions and at the same time do not cause any warnings, bugs or other problems. All the source files and directories referenced from this chapter are included in the attachment.

\section{Merge tests}
These tests check if all patches described in this thesis actually work and merges happen when they should happen. And vice versa if the merge should not happen because of some limitations, these tests check that the merge does not happen or cause any other problems. They are all included directly in the patches in the form of standard kernel self-tests. Self-tests are located in \verb|tools/testing/selftests| and can be build using \verb|make|. The source file \verb|vm/mremap_test.c| contains \fullref{sec:expand_merge_test} among other tests that are not part of this thesis, the file \verb|vm/merge_tests.c| contains all the other tests described below. They can both be executed by using the executables of the same name, \verb|vm/mremap_test| and \verb|vm/merge_tests| respectively.

\subsection{Expand merge test}
\label{sec:expand_merge_test}
This test validates that the merge is called when expanding a mapping in place. A mapping containing three pages is created and middle page is unmapped, which splits the mapping into two. Then the mapping containing the first page is expanded so that it fills the created hole. The two parts should merge creating a single mapping with three pages as in the beginning.

\subsection{Page offset update merge test}
\label{sec:page_offset_update_merge_test}
This test checks that for not shared mappings, page offset update happens and can lead to a previously impossible merge. The test creates a mapping and unmaps its middle part, creating two separate mappings (with an identical AV) with a space between them. It then tries to move the second mapping next to the first one to merge them. There is a subvariant of the test for shared mappings that verifies that the merge does not happen for shared mappings.

\subsection{Different AV merge test}
\label{sec:different_av_merge_test}
This test verifies that for not shared mappings with different \gls{av}s, merge is possible. It creates two mappings with a gap between them to force the kernel to assign different AVs to the mappings. It then joins the mappings by enlarging the first one so that the only remaining obstacle is the difference between AVs. There is a subvariant of the test for shared mappings that verifies that the merge does not happen for shared mappings.

\subsection{Different AV and pgoff update merge tests}
These tests check that for not shared mappings with different AVs, page offset update happens and can lead to a merge. They are basically a combination of the previous two tests.

\subsection{Spacing test}
The test creates mappings with spaces between them and then moves the mappings together. They should all merge into a single mapping if supported by the kernel.

\subsection{Regroup test}
This test creates two separate mappings (with different AVs) with a space between them. It then tries to move the second mapping next to the first one to merge them.

\section{Analytic helper programs}
Scripts and programs used for testing how the kernel works. They all reside in the \verb|sources/analytic| folder in the attachment.

\subsection{Print memory script}
A simple shell script that prints the memory mappings of a process with the given name.

\subsection{Process memory structure print}
This program creates and prints pointers to different data types to examine the process memory structure.

\subsection{VMA, AV and AVC print}
The root process is forked and then its child is forked again, creating parent, child and grandchild processes. The parent, child and grandchild VMAs are printed including their supporting structures - AVs and AVCs. Printing is done using patched \verb|mremap()| call that, if used correctly, only prints the information and does not actually affect the mappings in any way. The patch file is named 0001-Printing.patch.

\section{Other tests}
These tests cover corner cases including page offset update not necessarily linked to a merge, merging of partially shared mappings and merging of incompatible predecessor and successor mappings. They are again included in the patches as kernel self-tests.

\subsection{Page offset update test}
This test checks that for not shared mappings, page offset update happens even when a merge is not possible for other reasons. The test creates a mapping and unmaps its middle part, creating two separate mappings (with an identical AV) with a space between them. It changes the memory protection of the second mapping and then moves the second mapping next to the first one. The page offset should be updated but no merge will happen, because the memory protection does not match. To check that the page offset update actually happened, the memory protection is unified to allow a merge. If the page offset update did not happen, the merge will not happen. There is a subvariant of the test for shared mappings that verifies that the page offset update does not happen for shared mappings.

\subsection{Page offset and AV update partially shared merge test}
The test proves that even shared memory areas can be merged, provided they are merged with a non-shared memory area in the correct order. The test creates a mapping and forks to make it a COW shared mapping. It then creates another mapping that is not shared and moves it next to the shared one. The merge should be possible, because only the moved mapping cannot be shared.

\subsection{Filling a gap between incompatible predecessor and successor}
This test creates two blocks with a gap in between and forks to create a parent-child relation where memory is shared. Then it creates a new block that can fill the gap. The block is created elsewhere and is moved into the gap after the new block has been faulted. Merge should be possible only with one of the blocks, namely the predecessor, not both of them. This happens because shared memory between two processes makes it impossible to merge predecessor and successor, which have different AVs.

%\subsection{Child test}
%VMA with child process created and exited DO merge\break
%\gls{opt}


%\subsection{Pageout test}
%\gls{opt}

%\section{Testing on emulated HW}

%Testing on emulated HW is very useful when debugging a new version of kernel. It can quickly boot up and run several tests to ensure the changes are not fatal and more robust testing can follow on normal HW. Testing on normal HW is problematic, because a spare HW is needed in case something goes wrong and even on spare HW it is inconvenient to choose alternative boot option to be able to build a fixed version of the kernel.

%\subsection{Qemu}
%Can simulate memory, processors, disk for swapping

%Limits to testing of speed, where memory can be slower or faster compared to normal HW.

%\subsection{Virtme}
%to do ...

%\subsection{Results}
%to do ...
